import _Object$assign from 'babel-runtime/core-js/object/assign';
import React, { Component } from 'react';
import { connect } from 'react-redux';
import PropTypes from 'prop-types';
import { getActionPermissions, getRestriction } from './RestrictionValidatorUtil';

function RestrictionValidator(props) {
  var children = props.children,
      features = props.features,
      module = props.module,
      action = props.action;

  var Element = children.type,
      elementProps = children.props;

  var _getRestriction = getRestriction(features, module, action),
      isShow = _getRestriction.isShow,
      isReadOnly = _getRestriction.isReadOnly,
      _getRestriction$readO = _getRestriction.readOnlyMessage,
      readOnlyMessage = _getRestriction$readO === undefined ? "" : _getRestriction$readO;

  if (!isShow) {
    return null;
  } else {
    return React.createElement(Element, _Object$assign({}, elementProps, { isReadOnly: isReadOnly, readOnlyMessage: readOnlyMessage }));
  }
}

RestrictionValidator.propTypes = {
  module: PropTypes.string,
  children: PropTypes.Component,
  features: PropTypes.array,
  action: PropTypes.string
};

export default RestrictionValidator;