'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRedux = require('react-redux');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _RestrictionValidatorUtil = require('./RestrictionValidatorUtil');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function RestrictionValidator(props) {
  var children = props.children,
      features = props.features,
      module = props.module,
      action = props.action;

  var Element = children.type,
      elementProps = children.props;

  var _getRestriction = (0, _RestrictionValidatorUtil.getRestriction)(features, module, action),
      isShow = _getRestriction.isShow,
      isReadOnly = _getRestriction.isReadOnly,
      _getRestriction$readO = _getRestriction.readOnlyMessage,
      readOnlyMessage = _getRestriction$readO === undefined ? "" : _getRestriction$readO;

  if (!isShow) {
    return null;
  } else {
    return _react2.default.createElement(Element, Object.assign({}, elementProps, { isReadOnly: isReadOnly, readOnlyMessage: readOnlyMessage }));
  }
}

RestrictionValidator.propTypes = {
  module: _propTypes2.default.string,
  children: _propTypes2.default.Component,
  features: _propTypes2.default.array,
  action: _propTypes2.default.string
};

exports.default = RestrictionValidator;